routes/web.php
<?php

use App\Http\Controllers\AlbumController;
use App\Http\Controllers\ArtistController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\CustomerController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\IndexController;
use App\Http\Controllers\InvoiceController;
use App\Http\Controllers\PlaylistController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\TrackController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/* Index : show all * Show : show one * Create : show form to create * Store : store new * Edit : show form to edit * Update : update * Destroy : delete */
Route::get('/', [IndexController::class, 'index'])->name('index');

Route::get('/register', [UserController::class, 'create'])->name('register');
Route::get('/login', [UserController::class, 'login'])->name('login');
Route::get('/logout', [UserController::class, 'logout'])->name('logout');

Route::name('users.')->group(function () {
    Route::post('/users/authenticate', [UserController::class, 'authenticate'])->name('authenticate');
    Route::post('/users', [UserController::class, 'store'])->name('store');
    Route::get('/account', [UserController::class, 'accountIndex'])->name('account');
    Route::patch('/users/{user}', [UserController::class, 'update'])->name('update');
});

Route::name('albums.')->group(function () {
    Route::get('/albums', [AlbumController::class, 'index'])->name('index');
    Route::get('/albums/create', [AlbumController::class, 'create'])->name('create');
    Route::post('/albums', [AlbumController::class, 'store'])->name('store');
    Route::get('/albums/export/', [AlbumController::class, 'export'])->name('export');
    Route::post('/albums/{album}/cart', [AlbumController::class, 'addToCart'])->name('cart');
    Route::get('/albums/{album}/export', [AlbumController::class, 'exportOne'])->name('export.one');
    Route::get('/albums/{album}/edit', [AlbumController::class, 'edit'])->name('edit');
    Route::post('/albums/{album}/restore', [AlbumController::class, 'restore'])->name('restore');
    Route::delete('/albums/{album}', [AlbumController::class, 'destroy'])->name('destroy');
    Route::put('/albums/{album}', [AlbumController::class, 'update'])->name('update');
    Route::get('/albums/{album}', [AlbumController::class, 'show'])->name('show');
});

Route::name('tracks.')->group(function () {
    Route::get('/tracks', [TrackController::class, 'index'])->name('index');
    Route::get('/tracks/create', [TrackController::class, 'create'])->name('create');
    Route::get('/tracks/{track}', [TrackController::class, 'edit'])->name('edit');
    Route::put('/tracks/{track}', [TrackController::class, 'update'])->name('update');
    Route::post('/tracks', [TrackController::class, 'store'])->name('store');
    Route::delete('/tracks/{track}', [TrackController::class, 'destroy'])->name('destroy');
    Route::post('/tracks/{track}/restore', [TrackController::class, 'restore'])->name('restore');
});

Route::name('artists.')->group(function () {
    Route::get('/artists', [ArtistController::class, 'index'])->name('index');
    Route::get('/artists/export', [ArtistController::class, 'export'])->name('export');
    Route::get('/artists/create', [ArtistController::class, 'create'])->name('create');
    Route::delete('/artists/{artist}', [ArtistController::class, 'destroy'])->name('destroy');
    Route::get('/artists/{artist}/edit', [ArtistController::class, 'edit'])->name('edit');
    Route::post('/artists/{artist}/restore', [ArtistController::class, 'restore'])->name('restore');
    Route::put('/artists/{artist}', [ArtistController::class, 'update'])->name('update');
    Route::post('/artists', [ArtistController::class, 'store'])->name('store');
});

Route::name('playlists.')->group(function () {
    Route::get('/playlists', [PlayListController::class, 'index'])->name('index');
    Route::get('/playlists/{playlist}/export', [PlaylistController::class, 'export'])->name('export');
    Route::get('/playlists/create', [PlaylistController::class, 'create'])->name('create');
    Route::get('/playlists/{playlist}', [PlayListController::class, 'show'])->name('show');
    Route::get('/playlists/{playlist}/create', [PlaylistController::class, 'createTrack'])->name('tracks.create');
    Route::post('/playlists/{playlist}', [PlayListController::class, 'storeTrack'])->name('tracks.store');
    Route::delete('/playlists/{playlist}', [PlaylistController::class, 'destroy'])->name('destroy');
    Route::delete('/playlists/{playlist}/{track}', [PlayListController::class, 'destroyTrack'])->name('destroy.track');
    Route::post('/playlists', [PlayListController::class, 'store'])->name('store');
});

Route::name('invoices.')->group(function () {
    Route::get('/invoices', [InvoiceController::class, 'index'])->name('index');
    Route::delete('/invoices/{invoice}', [InvoiceController::class, 'destroy'])->name('destroy');
    Route::get('/invoices/{invoice}', [InvoiceController::class, 'show'])->name('show');
});

Route::name('cart.')->group(function () {
    Route::get('/cart', [CartController::class, 'index'])->name('index');
    Route::get('/cart/success', [CartController::class, 'success'])->name('success');
    Route::post('/cart', [CartController::class, 'store'])->name('store');
    Route::post('/cart/create-step-one', [CartController::class, 'createStepOneStore'])->name('create.step.one.store');
    Route::post('/cart/{track}', [CartController::class, 'addToCart'])->name('add');
    Route::delete('/cart/{id}', [CartController::class, 'deleteFromCart'])->name('delete');
    // we could use PUT if route --> /cart/{id}/quantity
    Route::patch('/cart/{id}', [CartController::class, 'update'])->name('update');
});

Route::name('customers.')->group(function () {
    Route::get('/customers', [CustomerController::class, 'index'])->name('index');
    Route::get('/customers/create', [CustomerController::class, 'create'])->name('create');
    Route::delete('/customers/{customer}', [CustomerController::class, 'destroy'])->name('destroy');
    Route::post('/customers', [CustomerController::class, 'store'])->name('store');
    Route::get('/customers/{customer}/edit', [CustomerController::class, 'edit'])->name('edit');
    Route::post('/customers/{customer}/restore', [CustomerController::class, 'restore'])->name('restore');
    Route::put('/customers/{customer}', [CustomerController::class, 'update'])->name('update');
});

Route::name('employees.')->group(function () {
    Route::get('/employees', [EmployeeController::class, 'index'])->name('index');
    Route::get('/employees/create', [EmployeeController::class, 'create'])->name('create');
    Route::delete('/employees/{employee}', [EmployeeController::class, 'destroy'])->name('destroy');
    Route::post('/employees', [EmployeeController::class, 'store'])->name('store');
    Route::get('/employees/{employee}/edit', [EmployeeController::class, 'edit'])->name('edit');
    Route::post('/employees/{employee}/restore', [EmployeeController::class, 'restore'])->name('restore');
    Route::put('/employees/{employee}', [EmployeeController::class, 'update'])->name('update');
    Route::post('/employees/{employee}/account', [EmployeeController::class, 'storeAccount'])->name('store.account');
});

Route::name('roles.')->group(function () {
    Route::get('/roles', [RoleController::class, 'index'])->name('index');
    Route::get('/roles/create', [RoleController::class, 'create'])->name('create');
    Route::post('/roles', [RoleController::class, 'store'])->name('store');
    Route::get('/roles/{role}/edit', [RoleController::class, 'edit'])->name('edit');
    Route::put('/roles/{role}', [RoleController::class, 'update'])->name('update');
    Route::delete('/roles/{role}', [RoleController::class, 'destroy'])->name('destroy');
});

Route::fallback(fn () => abort(404));

app/Models/Playlist.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Playlist extends Model
{
    use HasFactory;

    protected $fillable = ['name'];

    public function playlistTracks() {
        return $this->hasMany(PlaylistTrack::class, 'playlist_id');
    }

    public function tracks() {
        return $this
            ->hasManyThrough(Track::class, PlaylistTrack::class, 'playlist_id', 'id', 'id', 'track_id')
            ->orderBy('playlist_track.created_at', 'desc');
    }

    public static function boot() {
        parent::boot();
        // we could use onDeleteCascade if we want to
        static::deleting(fn($playlist) => $playlist->playlistTracks()->delete());
    }
}

app/Models/Track.php
<?php

namespace App\Models;

use Gloudemans\Shoppingcart\Contracts\Buyable;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\SoftDeletes;
use Kyslik\ColumnSortable\Sortable;

class Track extends Model implements Buyable
{
    use HasFactory, SoftDeletes, Sortable;

    protected $sortable = ['name', 'milliseconds', 'unit_price', 'genre.name'];
    protected $sortableAs = ['invoice_items_sum_quantity'];
    protected $fillable = ['name', 'album_id', 'media_type_id', 'genre_id', 'composer', 'milliseconds', 'bytes', 'unit_price'];
    protected $with = ['mediaType', 'genre']; // eager loading by default - optimize request !

    public function album(): BelongsTo {
        return $this->belongsTo(Album::class, 'album_id')->withTrashed();
    }

    public function genre() {
        return $this->belongsTo(Genre::class, 'genre_id');
    }

    public function mediaType() {
        return $this->belongsTo(MediaType::class, 'media_type_id');
    }

    public function invoiceItems() {
        return $this->hasMany(InvoiceItem::class, 'track_id');
    }

    public function getArtistAttribute()
    {
        return $this->album?->artist?->name ?? 'Artiste inconnu';
    }

    public function getMinutesAttribute()
    {
        return gmdate('H:i:s', $this->milliseconds/1000);
    }

    public function toSeconds()
    {
        return floor($this->milliseconds/1000);
    }

    public function getBuyableIdentifier($options = null)
    {
        return $this->id;
    }

    public function getBuyableDescription($options = null)
    {
        return $this->name;
    }

    public function getBuyablePrice($options = null)
    {
        return $this->unit_price;
    }

    public function getPopularityAttribute() {
        $popularity = config('popularity');

        foreach ($popularity as $current)
            if ($this->invoice_items_sum_quantity < $current['to'])
                return $current['result'];

        return 'Aucune';
    }

    public function artistSortable($query, $direction) {
        return $query->leftjoin('albums', 'tracks.album_id', '=', 'albums.id')
            ->leftjoin('artists', 'albums.artist_id', '=', 'artists.id')
            ->orderBy('artists.name', $direction);
    }

    public function scopePopular($query, int $total = 5) {
        return $query->withSum('invoiceItems as quantity_sum', 'quantity')->orderBy('quantity_sum', 'desc')->take($total);
    }

    public function scopeFilter($query, array $filter) {
        if ($filter['search'] ?? false) {
            return $query->where('name', 'like', '%' . request('search') . '%')
                ->orWhereHas('genre', fn($genre) => $genre->where('name', 'like', '%' . request('search') . '%'))
                ->orWhereHas('album.artist', fn($artist) => $artist->where('name', 'like', '%' . request('search') . '%'));
        }

        return $query;
    }
}

app/Http/Controllers/PlaylistController.php
<?php

namespace App\Http\Controllers;

use App\Exports\PlaylistExport;
use App\Models\Playlist;
use App\Models\Track;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Maatwebsite\Excel\Facades\Excel;

class PlaylistController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
        $this->middleware('permission:playlists.create')->only(['create', 'createTrack', 'store', 'storeTrack']);
        $this->middleware('permission:playlists.delete')->only(['destroy', 'destroyTrack']);
    }

    public function export(Playlist $playlist){
        return Excel::download(new PlaylistExport($playlist), 'playlist_'.$playlist->name.'.xlsx');
    }

    public function index(){
        $playlists = Playlist::withCount('tracks')->latest()->paginate(15);
        return view('playlists.index')->with('playlists', $playlists);
    }

    public function show(Playlist $playlist){
        $tracks = $playlist->tracks()->sortable()->with('album.artist:id,name')->paginate(15);

        return view('playlists.show')
            ->with('playlist', $playlist)
            ->with('tracks', $tracks);
    }

    public function create(){
        return view('playlists.create');
    }

    public function createTrack(Playlist $playlist){
        // taking all id's that already in that playlist
        $existingIds = $playlist->tracks()->pluck('id');
        $tracks = Track::whereNotIn('id', $existingIds)->orderBy('name')->get(['id', 'name']);
        return view('playlists.tracks.create')
            ->with('playlist', $playlist)
            ->with('tracks', $tracks);
    }

    public function store(Request $request){
        $formFields = $request->validate([
            'name' => ['required', 'min:3', Rule::unique('playlists')]
        ]);
        Playlist::create($formFields);
        return back()->with('success', 'Création réussie avec succès !');
    }

    public function storeTrack(Request $request, Playlist $playlist) {
        $formFields = $request->validate([
            'track_id' => ['required', Rule::unique('playlist_track')->where(fn ($query) => $query->where('playlist_id', $playlist->id))]
        ]);
        $playlist->playlistTracks()->create($formFields);
        return back()->with('success', 'Création réussie avec succès !');
    }

    public function destroy(Playlist $playlist){
        $playlist->deleteOrFail();
        return redirect()->route('playlists.index')->with('success', 'Suppression avec succès !');
    }

    public function destroyTrack(Playlist $playlist, Track $track){
        $playlist->playlistTracks()->where('track_id', '=', $track->id)->delete();
        return back()->with('success', 'Suppression avec succès !');
    }
}

resources/views/playlists/create.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-title>
        <x-slot name="pageHeading">
            Création d'une <span class="text-blue-600">playlist</span>
        </x-slot>
        <a href="{{ route('playlists.index') }}" class="cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Retour aux playlists
        </a>
    </x-title>

    <div class="flex max-w-lg mx-auto flex-col mt-10">
        <div class="p-8 bg-white rounded shadow">
            <div class=" text-center">
                <span class="text-sm text-blueGray-400 content-center">Playlists</span>
                <h4 class="mb-6 text-3xl">Créer une playlist</h4>
            </div>
            <form method="POST" action="{{route('playlists.store')}}" role="form" enctype="multipart/form-data">
                @csrf
                <input
                    value="{{ old('name') }}"
                    class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none @error('name') border-2 border-red-500 @enderror"
                    type="text" name="name" placeholder="Nom de la playlist" required>
                @error('name')<p class="text-red-500 text-xs italic">{{$message}}</p>@enderror
                <button class="mt-4 block w-full p-4 text-center text-xs text-white font-semibold leading-none bg-blue-600 hover:bg-blue-700 rounded">Valider les informations</button>
            </form>
        </div>
    </div>
</x-layout>

resources/views/playlists/index.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-title>
        <x-slot name="pageHeading">
            Liste des <span class="text-blue-600">playlists</span>
        </x-slot>
        @can('playlists.create')
            <a href="{{route('playlists.create')}}" class="cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-green-500 hover:bg-green-600 border border-green-600 rounded-md shadow-button">
                Ajouter une playlist
            </a>
        @endcan
    </x-title>

    <div class="flex flex-wrap mt-10 -mb-4">
        @foreach($playlists as $playlist)
            <div class="w-full md:w-1/2 lg:w-1/3 px-3 mb-4">
                <a href="{{route('playlists.show', $playlist->id)}}">
                    <div class="py-2 px-2 text-center bg-white rounded shadow">
                        <h3 class="mb-2 text-2xl font-bold font-heading">{{$playlist->name}}</h3>
                        <span class="text-3xl text-blue-600 font-bold font-heading">{{$playlist->tracks_count}}</span>
                        <p class="mt-2 text-blueGray-400">titres présents</p>
                    </div>
                </a>
            </div>
        @endforeach
    </div>

    @if ($playlists->hasPages())
        <div class="mt-10">
            {{$playlists->links()}}
        </div>
    @endif
</x-layout>

resources/views/playlists/show.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-title>
        <x-slot name="pageHeading">
            Playlist <span class="text-blue-600">{{$playlist->name}}</span>
        </x-slot>

        <a href="{{ route('playlists.export', $playlist->id) }}" class="cursor-pointer px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Exporter <i class="ml-2 fa fa-file-excel-o" aria-hidden="true"></i>
        </a>

        @can('playlists.create')
            <a href="{{ route('playlists.tracks.create', $playlist->id) }}" class="ml-2 cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-green-500 hover:bg-green-600 border border-green-600 rounded-md shadow-button">
                Ajouter un titre
            </a>
        @endcan
        @can('playlists.delete')
            <form action="{{ route('playlists.destroy', $playlist->id) }}" method="POST" class="inline m-0">
                @csrf @method('DELETE')
                <button class="ml-2 cursor-pointer px-4 py-2 text-sm text-white font-medium bg-red-500 hover:bg-red-600 border border-red-600 rounded-md shadow-button">X</button>
            </form>
        @endcan
    </x-title>

    <div class="relative overflow-x-auto shadow-md sm:rounded-lg mt-10">
        <table class="w-full text-sm text-left text-gray-500 dark:text-gray-400">
            <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
            <tr>
                <th scope="col" class="px-6 py-3">@sortablelink('name', 'Titre')</th>
                <th scope="col" class="px-6 py-3">@sortablelink('artist', 'Artiste')</th>
                <th scope="col" class="px-6 py-3">@sortablelink('genre.name', 'Genre')</th>
                <th scope="col" class="px-6 py-3">@sortablelink('milliseconds', 'Durée')</th>
                <th scope="col" class="px-6 py-3">@sortablelink('unit_price', 'Prix')</th>
                <th scope="col" class="px-6 py-3"><span class="sr-only">Actions</span></th>
            </tr>
            </thead>
            <tbody>
            @foreach($tracks as $track)
                <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                    <th scope="row" class="px-6 py-4 font-medium text-gray-900 dark:text-white whitespace-nowrap">{{$track->name}}</th>
                    <td class="px-6 py-4">{{$track->album?->artist?->name ?? 'Artiste supprimé'}}</td>
                    <td class="px-6 py-4">{{$track->genre->name}}</td>
                    <td class="px-6 py-4">{{$track->minutes}}</td>
                    <td class="px-6 py-4">{{$track->unit_price}}Є</td>
                    <td class="px-6 py-4">
                        <div class="flex justify-end">
                            @can('cart')
                                <form action="{{route('cart.add', $track)}}" method="POST">
                                    @csrf <button type="submit" class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded">🛒</button>
                                </form>
                            @endcan
                            @can('playlists.delete')
                                <form action="{{route('playlists.destroy.track', ['playlist' => $playlist, 'track' => $track])}}" method="POST">
                                    @csrf @method('DELETE')
                                    <button type="submit" class="ml-1 border hover:bg-gray-50 font-semibold py-1 px-2 rounded">❌</button>
                                </form>
                            @endcan
                        </div>
                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>

    @if ($tracks->hasPages())
        <div class="mt-10">
            {{$tracks->links()}}
        </div>
    @endif
</x-layout>